commlibrary(httr)
library(jsonlite)
library(foreach)


api_token = "glpat-B-eAynEzWLdsZkT1CUtG"
url = "https://renkulab.io/gitlab/api/v4/"

projects_url = paste(url,"projects",sep="")

#load projects
projects_data <- read.csv("./data/projects.csv")
#Getting all commits data

foreach(project_id=projects_data$id, .combine = c) %do% {
  commits_url = paste(projects_url,"/",project_id,"/repository/commits",sep="")
  res = GET(commits_url,
            query = list( private_token = api_token))
  json_commits = fromJSON(rawToChar(res$content))
  
  while(res$status_code == 429){
    print("sleeping 300 sec an retrying")
    #Too many calls wait 1 minute
    Sys.sleep(300)
    res = GET(commits_url,
              query = list( private_token = api_token))
    json_commits = fromJSON(rawToChar(res$content))
  }
  
  print(nrow(json_commits))
  
  if(is.null(nrow(json_commits)))
  {
    0
  }else{
    nrow(json_commits)  
  }
  
} -> commits


projects_data$commits_count <- commits
write.csv(projects_data,"./data/projects_commits.csv")


