library(httr)
library(jsonlite)
library(foreach)


api_token = "glpat-B-eAynEzWLdsZkT1CUtG"
url = "https://renkulab.io/gitlab/api/v4/"

users_url = paste(url,"users",sep="")

#load users
users_data <- read.csv("./data/users.csv")

#Getting all events data

foreach(user_id=users_data$id, .combine = c) %do% {
  events_url = paste(users_url,"/",user_id,"/events",sep="")
  res = GET(events_url,
            query = list( private_token = api_token))
  json_events = fromJSON(rawToChar(res$content))
  
  while(res$status_code == 429){
    print("sleeping 300 sec an retrying")
    #Too many calls wait 1 minute
    Sys.sleep(300)
    res = GET(events_url,
              query = list( private_token = api_token))
    json_events = fromJSON(rawToChar(res$content))
  }
  
  print(nrow(json_events))
  
  if(is.null(nrow(json_events)))
  {
    0
  }else{
    nrow(json_events)  
  }
  
  
} -> events

users_data$event_number <- events
write.csv(users_data,"./data/user_events.csv")



