library(httr)
library(jsonlite)
library(foreach)


api_token = "glpat-B-eAynEzWLdsZkT1CUtG"
url = "https://renkulab.io/gitlab/api/v4/"

projects_url = paste(url,"projects",sep="")

#Getting all projects data

page = 1
GET(projects_url,
    query = list(per_page = 100, 
                 page = page,
                 order_by = "created_at",
                 private_token = api_token)
) -> res

json_projects = fromJSON(rawToChar(res$content))

projects = data.frame( id = json_projects$id,
                       name = json_projects$name,
                       created_at = json_projects$created_at,
                       last_active = json_projects$last_activity_at,
                       owner = json_projects$owner$id,
                       forks = json_projects$forks_count
)


StartDate = as.Date("2022-01-01","%Y-%m-%d")
projectDate = as.Date(tail(projects$created_at, 1),"%Y-%m-%d")

while(projectDate > StartDate){
  page = page + 1
  GET(projects_url,
      query = list(per_page = 100, 
                   page = page,
                   order_by = "created_at",
                   private_token = api_token)
  ) -> res
  
  json_projects = fromJSON(rawToChar(res$content))
  
  tmp_projects = data.frame( id = json_projects$id,
                             name = json_projects$name,
                             created_at = json_projects$created_at,
                             last_active = json_projects$last_activity_at,
                             owner = json_projects$owner$id,
                             forks = json_projects$forks_count
  )
  
  projectDate <- as.Date(tail(tmp_projects$created_at, 1),"%Y-%m-%d")
  projects = rbind(projects, tmp_projects)
}

write.csv(projects,"./data/projects.csv")
