library(httr)
library(jsonlite)
library(foreach)


api_token = "glpat-B-eAynEzWLdsZkT1CUtG"
url = "https://renkulab.io/gitlab/api/v4/"
users_url = paste(url,"users",sep="")



#Getting all users data // by default the API returns the data order by ID

page = 1
u = 1
GET(users_url,
    query = list( private_token = api_token,
                  exclude_internal = "true",
                  per_page = 100, 
                  page = page
    )
) -> res

json_users = fromJSON(rawToChar(res$content))

StartDate = as.Date("2022-01-01","%Y-%m-%d")

foreach(user_id=json_users$id, .combine = c) %do% {
  user_url = paste(users_url,"/",user_id,sep="")
  res = GET(user_url,
            query = list( private_token = api_token))
  json_user = fromJSON(rawToChar(res$content))
  print(user_id)
  print(json_user$created_at)
  print(u)
  u = u + 1
  if(!is.null(json_user$created_at)){
    as.Date(json_user$created_at,"%Y-%m-%d")  
  }else{
    as.Date("2022-01-02","%Y-%m-%d")
  }
} -> created_at

users <- data.frame(
  id = json_users$id,
  username = json_users$username,
  name = json_users$name,
  created_at = created_at
)

last_user = tail(users,1)
userDate = as.Date(last_user$created_at)

while(userDate > StartDate){
  page = page + 1
  GET(users_url,
      query = list( private_token = api_token,
                    exclude_internal = "true",
                    per_page = 100, 
                    page = page
      )
  ) -> res
  
  json_users = fromJSON(rawToChar(res$content))
  
  foreach(user_id=json_users$id, .combine = c) %do% {
    user_url = paste(users_url,"/",user_id,sep="")
    res = GET(user_url,
              query = list( private_token = api_token))
    json_user = fromJSON(rawToChar(res$content))
    
    while(res$status_code == 429){
      print("sleeping 300 sec an retrying")
      #Too many calls wait 1 minute
      Sys.sleep(300)
      res = GET(user_url,
                  query = list( private_token = api_token))
      json_user = fromJSON(rawToChar(res$content))
    }
    
    print(user_id)
    print(json_user$created_at)
    print(u)
    u = u + 1
    
    if(!is.null(json_user$created_at)){
      as.Date(json_user$created_at,"%Y-%m-%d")  
    }else{
      as.Date("2022-01-02","%Y-%m-%d")
    }
  } -> created_at
  
  
  tmp_users <- data.frame(
    id = json_users$id,
    username = json_users$username,
    name = json_users$name,
    created_at = created_at
  )
  
  last_user = tail(users,1)
  userDate = as.Date(last_user$created_at)
  users = rbind(users, tmp_users)
}

write.csv(users,"./data/user.csv")